%% Prednaska 1

% Matlab: více slidy (Martin Trnecka) <https://www.dropbox.com/s/idbyumx5xgi339a/matlab.pdf?dl=0 
% https://www.dropbox.com/s/idbyumx5xgi339a/matlab.pdf?dl=0>

% Nápověda k příkazům 
% help prikaz
help sum
%% Práce s obrázky

% nacteni obrazku
% imread(cesta);
I=imread('pastelky_gray.png');

% zobrazeni obrazku
% imshow(obrazek);
imshow(I);

%%
% roztazeni intenzit (vsechny hodnoty mensi nez low budou nastaveny na 0,
% vsechny vetsi nez height na 255, a hodnoty mezi low a height budou
% roztazeny pravidelne mezi 0 a 255
% imshow(obrazek, [low,high]);
% [] na 0 je nastavena nejnizsi hodnota a na 255 nejvyssi
low = 48
high = 212
imshow(I,[low,high]);

%%
% hodnota pixelu na souradnicich 1, 1 (funkce display vypise vystup)
% I(x,y) 
% pozor indexuje se od 1
display(I(1,1));

% velikost obrazku, h - vyska obrazku (pocet radku), w - sirka obrazku
% (pocet sloupcu), o - dimenze urcujici kolik hodnot je potreba k
% reprezentaci informace o obraze, barevny = 3, sedotonovy = 1)
% size(promenna)

[h,w,o] = size(I);
display(h);
display(w);
display(o);

%%
I_rgb = imread("pastelky.png");
figure, imshow(I_rgb);

display(I_rgb(1,1,:));

[h,w,o] = size(I);
display(h);
display(w);
display(o);
%%
% Vytvoreni vyrezu obrazku I(xmin:xmax, ymin:ymax)
xmin = 100
xmax = 250
ymin = 100
ymax = 250
J = I(xmin:xmax,ymin:ymax);

imshow(J);

%%
% vykresleni vice obrazku
% do noveho okna figure, imshow()
imshow(I);
figure, imshow(J);

%%
% vykresleni vice obrazku do jednoho
% subplot(pocetx, pocety, pozice), imshow()
subplot(1,2,1), imshow(I);
subplot(1,2,2), imshow(J);

%%
% ulozeni obrazku
% imwrite(obrazek,cesta)
imwrite(J,"pastelky_vyrez.png");

%%
% export obrazku
% exportgraphics(objekt,cesta);
imshow(I);
f = gcf;
exportgraphics(f,'pastelky.pdf');

%% 
% informace o obrazku
% imfinfo(cesta)
imfinfo('pastelky.png')

%%
% interaktivni prostredi pro praci s obrazky
% napriklad mereni vzdalenosti, prohlizeni hodnot jednotlivych obrazku
imtool(I);

%%
% cyklus for
for i = 1 : 10
    display(i);
end

%%
% cyklus while
i = 1;
while(i <= 10)
    display(i);
    i = i+1;
end

%%
% vetveni
i = 20
if (i > 0)
    display('vetsi');
else
    display('mensi');
end
%%
% pruchod obrazku pixel po pixelu (2 vnorene cykly)

for i = 1:h
    for j = 1:w
        L = 255-I;
    end
end

figure, imshow(L);
%%
% funkce

%    function I2 = negativ(I)
%    %NEGATIV Summary of this function goes here
%    %   Detailed explanation goes here
%
%          I2 = 255 - I;
%
%    end

M = negativ(I);
imshow(M);

%%
% Zobrazeni jednotlivych slozek obrazku

figure;
subplot(2,2,1), imshow(I_rgb);
subplot(2,2,2), imshow(I_rgb(:,:,1));
title('red');
subplot(2,2,3), imshow(I_rgb(:,:,2));
title('green');
subplot(2,2,4), imshow(I_rgb(:,:,3));
title('blue');

%% RGB to GRAY

figure, subplot(1,3,1), imshow(I_rgb);

% prumerovanim slozek
gray1 = (1/3)*I_rgb(:,:,1) + (1/3)*I_rgb(:,:,2) + (1/3)*I_rgb(:,:,3);
subplot(1,3,2), imshow(gray1,[]);

% vazeny prumer
gray2 = rgb2gray(I_rgb);
subplot(1,3,3), imshow(gray2,[]);

%% RGB to CMY

I_cmy = rgb2cmy(I_rgb);
%I = 255 - I2;
I_rgb2 = cmy2rgb(I_cmy);

figure, subplot(2,2,1), imshow(I_rgb);
title('RGB'); 
subplot(2,2,2), imshow(I_cmy);
title('CMY'); 
subplot(2,2,3), imshow(I_rgb2);
title('RGB');
%% CMY to RGB

I_rgb = imcomplement(I_cmy);
%I = 255 - I2;

figure, subplot(1,2,1), imshow(I_rgb);
title('RGB'); 
subplot(1,2,2), imshow(I_cmy);
title('CMY');

%% CMYK

% vytvoreni tranformace
% pro vice informaci, jake transformace je mozne vytvorit pouzijte:
% help makecform
C = makecform('srgb2cmyk');     %srgb (standard rgb) to cmyk 

% aplikace transformace
I_cmyk= applycform(I_rgb,C);

%% RGB to HSV

I_hsv = rgb2hsv(I_rgb);

figure, subplot(2,2,1), imshow(I_rgb);
title('RGB'); 
subplot(2,2,2), imshow(I_hsv(:,:,1));
title('hue'); 
subplot(2,2,3), imshow(I_hsv(:,:,2));
title('saturation'); 
subplot(2,2,4), imshow(I_hsv(:,:,3));
title('value');
%% HSV to RGB

I_rgb2 = hsv2rgb(I_hsv);

figure, imshow(I_rgb2);
%% RGB to YCbCr

I_ycbcr = rgb2ycbcr(I_rgb);

figure, subplot(2,2,1), imshow(I_rgb);
title('RGB'); 
subplot(2,2,2), imshow(I_ycbcr(:,:,1));
title('Y'); 
subplot(2,2,3), imshow(I_ycbcr(:,:,2));
title('Cb'); 
subplot(2,2,4), imshow(I_ycbcr(:,:,3));
title('Cr');
%% YCbCr to RGB

I_rgb2 = ycbcr2rgb(I_ycbcr);

figure, imshow(I_rgb2);
